/*
			(c) Copyright 1998-2000 - Tord Jansson
			======================================

		This file is part of the BladeEnc MP3 Encoder, based on
		ISO's reference code for MPEG Layer 3 compression, and might
		contain smaller or larger sections that are directly taken
		from ISO's reference code.

		All changes to the ISO reference code herein are either
		copyrighted by Tord Jansson (tord.jansson@swipnet.se)
		or sublicensed to Tord Jansson by a third party.

	BladeEnc is free software; you can redistribute this file
	and/or modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.



	------------    Changes    ------------

	2000-02-15  Pirandot

	-	reformatted, used 'static', less parameters

	---------------------------------------
*/


/**********************************************************************
 * ISO MPEG Audio Subgroup Software Simulation Group (1996)
 * ISO 13818-3 MPEG-2 Audio Encoder - Lower Sampling Frequency Extension
 *
 * $Id: loop-pvt.h,v 1.1 1996/02/14 04:04:23 rowlands Exp $
 *
 * Private interface declarations for loop.c
 *
 * $Log: loop-pvt.h,v $
 * Revision 1.1  1996/02/14 04:04:23  rowlands
 * Initial revision
 *
 * Received from Mike Coleman
 **********************************************************************/

#ifndef LOOP_PVT_H
#define LOOP_PVT_H

/*
  Revision History:

  Date        Programmer                Comment
  ==========  ========================= ===============================
  1995/10/01  mc@fivebats.com           created

*/


static	int outer_loop
(
	int						max_bits,
	frame_params			*fr_ps
);



static	int inner_loop
(
	int						max_bits
);



static	int part2_length
(
	frame_params			*fr_ps
);



static	int scale_bitcount (void);



static	void calc_noise (void);



static	int loop_break (void);



static	void preemphasis (void);



static	int amp_scalefac_bands
(
	int						iteration
);



static	void quantize (void);



static	int ix_max_tj
(
	unsigned int			begin,
	unsigned int			end
);



static	int count_bits (void);



static	int new_choose_table_tj
(
	unsigned int			begin,
	unsigned int			end
);



static	int choose_table (unsigned int max);



static	int count_bit_tj
(
	unsigned int			start,
	unsigned int			end,
	unsigned int			table
);



static	int bin_search_StepSize
(
	int						desired_rate,
	double					start
);





#endif
